﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Activities;
using LinqToTwitter;
using System.ComponentModel;

// Demo by Raffaele Rialdi. May 20, 2010
// http://www.iamraf.net
// malta@vevy.com

namespace Raf.WF4ActivityLibrary.Twitter
{
	public class TwitterInitActivity : CodeActivity<TwitterContext>
	{
		[RequiredArgument]
		public InArgument<string> ConsumerKey { get; set; }

		[RequiredArgument]
		public InArgument<string> ConsumerSecret { get; set; }

		public InArgument<bool> ClearCredentialCache { get; set; }

		protected override TwitterContext Execute(CodeActivityContext context)
		{
			string consumerKey = ConsumerKey.Get(context);
			string consumerSecret = ConsumerSecret.Get(context);
			bool clearCredentialCache = ClearCredentialCache.Get(context);

			// ====> oAuth authentication <====
			var auth = new DesktopOAuthAuthorization();
			auth.ConsumerKey = consumerKey;
			auth.ConsumerSecret = consumerSecret;
			auth.GetVerifier = () => { Console.WriteLine("Enter pin: "); return Console.ReadLine(); };

			auth.SignOn();

			// ====> clear credentials <====
			if(clearCredentialCache)
				auth.ClearCachedCredentials();

			var ctx = new TwitterContext(auth, "https://api.twitter.com/1/", "http://search.twitter.com/");
			return ctx;
		}
	}



}

