﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Activities;
using LinqToTwitter;

// Demo by Raffaele Rialdi. May 20, 2010
// http://www.iamraf.net
// malta@vevy.com

namespace Raf.WF4ActivityLibrary.Twitter
{
	public class TwitterPostActivity : CodeActivity<ulong>
	{
		[RequiredArgument]
		public InArgument<TwitterContext> TwitterContext { get; set; }

		[RequiredArgument]
		public InArgument<string> Text { get; set; }

		public InArgument<string> IdToReply { get; set; }

		/// <summary>
		/// This is the "screen_name"
		/// whose format is a string without "@" char
		/// </summary>
		public InArgument<string> UserDirect { get; set; }

		protected override ulong Execute(CodeActivityContext context)
		{
			try
			{
				TwitterContext ctx = this.TwitterContext.Get(context);
				string text = this.Text.Get(context);
				string idToReply = this.IdToReply.Get(context);
				string userDirect = this.UserDirect.Get(context);

				ulong id = 0;

				Status status;
				if(string.IsNullOrEmpty(userDirect))
				{
					if(!string.IsNullOrEmpty(idToReply))
						status = ctx.UpdateStatus(text, idToReply);
					else
						status = ctx.UpdateStatus(text);
					id = ulong.Parse(status.StatusID);
				}
				else
				{
					var dm = ctx.NewDirectMessage(userDirect, text);
					id = dm.ID;
				}

				return id;
			}
			catch(Exception err)
			{
				// log exception somewhere ...
				System.Diagnostics.Trace.WriteLine(err.ToString());
				return 0;
			}
		}




	}
}

