﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Activities;
using LinqToTwitter;
using System.Activities.Statements;

// Demo by Raffaele Rialdi. May 20, 2010
// http://www.iamraf.net
// malta@vevy.com

namespace Raf.WF4ActivityLibrary.Twitter
{
	public class TwitterQueryActivity : CodeActivity<IList<TwitterData>>
	{
		[RequiredArgument]
		public InArgument<TwitterContext> TwitterContext { get; set; }

		[RequiredArgument]
		public InOutArgument<ulong> LastId { get; set; }

		protected override IList<TwitterData> Execute(CodeActivityContext context)
		{
			try
			{
				TwitterContext ctx = this.TwitterContext.Get(context);
				ulong lastId = this.LastId.Get(context);
				if(lastId == 0)
					lastId = 1;	// twitter does not accept "0"

				var tweets = from tweet in ctx.Status
							 where tweet.Type == StatusType.Home && tweet.SinceID == lastId
							 select new TwitterData()
							 {
								 Text = tweet.Text,
								 Name = tweet.User.Name,
								 StatusID = ulong.Parse(tweet.StatusID),
							 };

				IList<TwitterData> result = tweets.ToList();
				if(result.Count > 0)
					this.LastId.Set(context, result.First().StatusID);

				return result;
			}
			catch(Exception err)
			{
				// log exception somewhere ...
				System.Diagnostics.Trace.WriteLine(err.ToString());
				return new List<TwitterData>();
			}
		}
	}
}



